\documentclass[12pt]{article}
\usepackage{graphicx}
\usepackage{epstopdf}
\usepackage{amssymb}
\usepackage{amsmath}

\def\ga{\alpha}
\def\gb{\beta}
\def\gc{\gamma}
\def\gd{\delta}
\def\ge{\epsilon}
\def\gz{\zeta}
\def\gy{\eta}
\def\th{\theta}
\def\gi{\iota}
\def\gk{\kappa}
\def\gl{\lambda}
\def\gm{\mu}
\def\gn{\nu}
\def\gx{\xi}
\def\gp{\pi}
\def\gr{\rho}
\def\gs{\sigma}
\def\gt{\tau}
\def\gu{\upsilon}
\def\ph{\phi}
\def\ch{\chi}
\def\ps{\psi}
\def\gw{\omega}

\def\gB{\Beta}
\def\gC{\Gamma}
\def\gD{\Delta}
\def\Th{\Theta}
\def\gL{\Lambda}
\def\gX{\Xi}
\def\gP{\Pi}
\def\gS{\Sigma}
\def\gU{\Upsilon}
\def\Ph{\Phi}
\def\Ps{\Psi}
\def\gW{\Omega}

\def\bA{{\bf A}}
\def\bB{{\bf B}}
\def\bC{{\bf C}}
\def\bD{{\bf D}}
\def\bE{{\bf E}}
\def\bF{{\bf F}}
\def\bG{{\bf G}}
\def\bH{{\bf H}}
\def\bI{{\bf I}}
\def\bJ{{\bf J}}
\def\bK{{\bf K}}
\def\bL{{\bf L}}
\def\bM{{\bf M}}
\def\bN{{\bf N}}
\def\bO{{\bf O}}
\def\bP{{\bf P}}
\def\bQ{{\bf Q}}
\def\bR{{\bf R}}
\def\bS{{\bf S}}
\def\bT{{\bf T}}
\def\bU{{\bf U}}
\def\bV{{\bf V}}
\def\bW{{\bf W}}
\def\bX{{\bf X}}
\def\bY{{\bf Y}}
\def\bZ{{\bf Z}}

\def\cA{{\cal A}}
\def\cB{{\cal B}}
\def\cC{{\cal C}}
\def\cD{{\cal D}}
\def\cE{{\cal E}}
\def\cF{{\cal F}}
\def\cG{{\cal G}}
\def\cH{{\cal H}}
\def\cI{{\cal I}}
\def\cJ{{\cal J}}
\def\cK{{\cal K}}
\def\cL{{\cal L}}
\def\cM{{\cal M}}
\def\cN{{\cal N}}
\def\cO{{\cal O}}
\def\cP{{\cal P}}
\def\cQ{{\cal Q}}
\def\cR{{\cal R}}
\def\cS{{\cal S}}
\def\cT{{\cal T}}
\def\cU{{\cal U}}
\def\cV{{\cal V}}
\def\cW{{\cal W}}
\def\cX{{\cal X}}
\def\cY{{\cal Y}}
\def\cZ{{\cal Z}}


\def\ba{{\bf a}}
\def\bb{{\bf b}}
\def\bc{{\bf c}}
\def\bd{{\bf d}}
\def\be{{\bf e}}
\def\bg{{\bf g}}
\def\bh{{\bf h}}
\def\bi{{\bf i}}
\def\bj{{\bf j}}
\def\bk{{\bf k}}
\def\bl{{\bf l}}
\def\bm{{\bf m}}
\def\bn{{\bf n}}
\def\bo{{\bf o}}
\def\bp{{\bf p}}
\def\bq{{\bf q}}
\def\br{{\bf r}}
\def\bs{{\bf s}}
\def\bt{{\bf t}}
\def\bu{{\bf u}}
\def\bv{{\bf v}}
\def\bw{{\bf w}}
\def\bx{{\bf x}}
\def\by{{\bf y}}
\def\bz{{\bf z}}

\def\b0{{\bf0}}
\def\o{\circ}
\def\x{\times}
\def\d{\partial}
\def\<{\langle}
\def\>{\rangle}
\def\R{{\mathbb R}}
\def\Z{{\mathbb Z}}
\def\Q{{\mathbb Q}}
\def\N{{\mathbb N}}
\def\C{{\mathbb C}}
\def\T{{\mathbb T}}
\def\Cinf{C^\infty}
\def\sb{\subseteq}
\def\sp{\superseteq}
\def\({\left(}
\def\){\right)}
\def\rank{\mbox{rank}\,}
\def\rk{\mbox{rank}\,}
\def\ddt{\frac d{dt}}
\def\corank{\mbox{corank}\,}
\def\cl{\hbox{cl}\,}
\def\im{\hbox{im}\,}
\def\Id{\hbox{Id}}
\def\Diff{\hbox{Diff}}
\def\tv{\pitchfork}
\def\ntv{\not\tv}
\def\codim{\hbox{codim}\,}
\def\tr{\hbox{tr}\,}
\def\cosec{\hbox{cosec}\,}
\def\const{\hbox{const}}
\def\lc{\lceil}
\def\rc{\rceil}
\def\lf{\lfloor}
\def\rf{\rfloor}
\def\sech{\hbox{sech}\,}
\def\csch{\hbox{csch}\,}
\def\grad{\hbox{grad}\,}
\def\nbhd{neighbourhood}
\def\dlim{\displaystyle\lim}
\def\dfrac#1#2{\displaystyle{#1\over#2}}
\def\dsum{\displaystyle\sum}
\def\dint{\displaystyle\int}
\def\diint{\displaystyle\iint}
\def\diiint{\displaystyle\iiint}
\def\doint{\displaystyle\oint}
\def\tlim{\textstyle\lim}
\def\tfrac#1#2{\textstyle{#1\over#2}}
\def\tsum{\textstyle\sum}
\def\tint{\textstyle\int}
\def\del{\nabla}
\def\div{\hbox{div}\,}
\def\curl{\hbox{curl}\,}
\def\intL{\int\limits}
\def\iintL{\iint\limits}
\def\iiintL{\iiint\limits}

\def\abs{\hbox{abs}\,}
\def\sgn{\hbox{sgn}\,}
\def\dom{\hbox{dom}\,}


\def\eval{\,\Bigl.\Bigl|}



\def\drawbox#1{\lower6pt\hbox{{\vbox{\hrule\hbox{\vrule\kern15pt
   \vbox{\kern10pt\vbox{\hbox{#1}}\kern10pt} 
   \kern18pt\vrule}\hrule}}}}

\def\picture #1 by #2 (#3){
  \medbreak
		$$\vbox to #2{
    \hrule width #1 height 0pt depth 0pt
    \vfill
    \special{picture #3}
  }$$
}

\def\scaledpicture #1 by #2 (#3 scaled #4){
  \dimen0=#1 
		\dimen1=#2
  \divide\dimen0 by 1000 
   \multiply\dimen0 by #4
  \divide\dimen1 by 1000 
   \multiply\dimen1 by #4
  \picture \dimen0 by \dimen1 (#3 scaled #4)}
%\input mypars
%The following are plain tex style parameters 

\baselineskip=12pt
\hoffset=0pt
\voffset=0 cm
\leftskip=0pt
\rightskip=0pt
\parindent=0cm

%And these are latex style parameters

\headsep=0cm
\headheight=0cm
\evensidemargin=0cm
\oddsidemargin=0cm
\parskip=12pt
\textwidth=16.5 true cm
\textheight=22 true cm
\topmargin=1cm

\def\Gr{Gr\"obner}
\def\kn{k[x_1,\dots,x_n]}
\def\lc{\mbox{\sc lc}}
\def\lt{\mbox{\sc lt}}
\def\lp{\mbox{\sc lp}}
\def\gcd{\mbox{\sc gcd}}
\def\red#1{\stackrel{#1}{\longrightarrow}}
\def\redplus#1{\stackrel{#1}{\longrightarrow}_+}

\newtheorem{theorem}{Theorem}[section]
\newtheorem{lemma}{Lemma}[section]
\newtheorem{definition}{Definition}[section]
\newtheorem{example}{Example}[section]
\newtheorem{corollary}{Corollary}[section]

\newenvironment{proof}
{\begin{trivlist}
\item[\hskip \labelsep {\bf Proof.}]
}
{\hfill$\Box$
\end{trivlist}}
           

\def\pagenumbers{\headline={\iftitle\hfil\global\titlefalse                     
   \else\hss\rm\folio\hss\fi}}                                                  
\newtoks\option                                                                 
\newtoks\solnhead                                                               
\newtoks\sheetname                                                              
\option={,}                                                                     
\def\separate#1,#2@{\def\optionid{#1}\def\optionname{#2}}                      
\def\fullwidth{\everypar{}\parindent=0pt\relax}                                 

\def\maketitle{
\begin{center}
{\sc Victoria University of Wellington\\
School of Mathematics, Statistics and Operations Research}\\
\smallskip
{\sl
Te Kura M{\=a}tai Tatauranga, Rangahau P{\=u}naha}
\end{center}
\expandafter\separate\the\option@
\hbox to\hsize{\hrulefill}
\nointerlineskip
\vskip3pt                                  
\hbox
to\hsize{\strut\rlap{\optionid}\hfill{\sc\optionname}\hfill\llap{\number\year}}          
\nointerlineskip
\vskip2pt
\hbox to\hsize{\hrulefill}}

\let\filbreak=\relax                                                           
\def\head{\filbreak\vskip 18pt\fullwidth                                    
   \def\filbreak{\global\let\filbreak=\fillbreak}%                            
   \centerline{\large\bf \the\sheetname}\nobreak
   \vskip 12pt minus 3pt}                                                       
\def\tutorial{\sheetname={Tutorial}\head}                                      
\def\assignment{\sheetname={Assignment}\head}                                  
\def\sheet#1{\sheetname={#1}\head}                                             
\def\showdue#1{\hbox to\hsize{\hfil Due: #1}
\vskip 5pt minus 3pt}

\leftmargin=0pt              

\begin{document}

\option={MATH 437,Gr\"obner Bases and Their Applications}        
\maketitle
\medskip 
\setcounter{section}5
\section{Multivariate Division Algorithm}

\subsection{Multivariate polynomial division}

Given a polynomial $f\in\kn$ and a term order we may naturally write
$f=a_1x^{\ga_1} +\dots+a_px^{\ga_p}$ where $x^{\ga_1}>\dots>x^{\ga_p}$. Define the
{\bf leading term} of $f$ to be
$\lt(f)=a_1x^{\ga_1}$, with {\bf leading power} $\lp(f)=x^{\ga_1}$ and {\bf
leading coefficient} $\lc(f)=a_1$.  The {\bf multidegree} of $f$ is the index vector of the leading term $\ga_1$.


Let's start with a simple example where we try to emulate the univariate division
algorithm and write $f=qg+r$. Let
\begin{eqnarray*}
f&=&6x^2y-x+4y^3-1\\
g&=&2xy+y^3
\end{eqnarray*}
We start with {\sc lex} ordering on $\Q[x,y]$ with $y<x$. Hence $\lp(f)=x^2y$ and
$\lp(g)=xy$. The aim is to divide the leading term of $f$ by that of $g$,
analogous with the previous special cases. Then let
\begin{eqnarray*}
f'&=&f-\frac{\lt(f)}{\lt(g)}g\\
&=&6x^2y-x+4y^3-1-\frac{6x^2y}{2xy}(2xy+y^3)\\
&=&-3xy^3-x+4y^3-1
\end{eqnarray*}
and now $\lp(f')=xy^3<\lp(f)$. We add ${\lt(f)}/{\lt(g)}=3x$ to the quotient and
repeat with $f'$. So
\begin{eqnarray*}
f''&=&f'-\frac{\lt(f')}{\lt(g)}g\\
&=&-3xy^3-x+4y^3-\frac{-3xy^3}{2xy}(2xy+y^3)\\
&=&-x+\tfrac32y^5+4y^3-1
\end{eqnarray*}
Now the leading power of $f''$, which is $x$, is no longer divisible by $\lp(g)$.
In the univariate case the process stops. However it is now possible that though
$\lp(g)\nmid\lp(f'')$, nevertheless it does divide some lower order term.  In this
example that does not happen, so we have
$$
f=(3x-\tfrac32y^2)g-x+\tfrac32y^5+4y^3.
$$

In {\sc deglex} however, while $\lp(f)=x^2y$ still, $\lp(g)=y^3$. Now we cannot
divide but there are lower order terms divisible by $\lp(g)$. So put the leading
term of $f$ straight in the remainder and start again with $f'=-x+4y^3-1$ which has
leading power $y^3$, divisible by $\lp(g)$ giving
$$
f''=4y^3-x-1-\frac{4y^3}{y^3}(y^3+2xy)=-x-1-8xy.
$$
No further division is possible, consistent with reducing the leading power of $f$
in respect of {\sc deglex} and we have simply
$$
f=4g+(6x^2y-x-1-8xy).
$$

In this setting we say that {\bf $f$ reduces to $h$ modulo $g$ in one step} if
$\lp(g)$ divides a term $X$ of $f$ and 
$$
h=f-\frac X{\lt(g)}g.
$$
We write
$$
f\stackrel{g}{\longrightarrow}h.
$$
Note from our example that $h$ certainly depends on the term order employed.

We now wish to generalise the above process to reduction modulo a set of
non-zero polynomials.  

\begin{example} 
Find the quotients and remainder in $\Q[x]$ when reducing
$f=x^2y+xy^2+y^2$ by $g_1=xy-1$ and $g_2=y^2-1$ with respect to {\sc lex} and $x>y$.\\[-5ex]
\end{example}

We need to holders for the quotients and this time we encounter terms in the divisor that are not divisible by either leading term of the $g_i$s. These must be transferred to the remainder before proceeding:
\[
\begin{array}{clr}
u_1:&x+y\\
u_2:&1&\underline{r:}\\[-1ex]
&\hrulefill&\\
xy-1&\multicolumn{1}{|l}{x^2y+xy^2+y^2}&\\
y^2-1&x^2y-x&\\[-1ex]
&\hrulefill\\
&xy^2+x+y^2&\\
&xy^2-y\\[-1ex]
&\hrulefill\\
&x+y^2+y&\\
&x\\[-1ex]
&\hrulefill\\
&y^2+y&x\\
&y^2-1\\[-1ex]
&\hrulefill\\
&y+1\\
&y+1\\[-1ex]
&\hrulefill\\
&0&y+1\\[-1ex]
&&\hrulefill\\
&&x+y+1
\end{array}
\]
Thus $f=(x+y)g_1+1.g_2+(x+y+1)$. However repeating this but with $g_2$ being used before $g_1$ gives
\[
f=xg_1+(x+1)g_2+(2x+1)
\]
so that we no longer have uniqueness of quotients and remainder.

\begin{definition}
Let $G=\{g_1,\dots,g_s\}\subseteq\kn$.  A polynomial $f\in\kn$ {\bf reduces to $h$
modulo $G$},
$f\stackrel{G}{\longrightarrow}_+h$,  if there is a sequence
$i_1,i_2,\dots,i_t$ such that
$$
f\stackrel{g_{i_1}}{\longrightarrow}h_1\stackrel{g_{i_2}}{\longrightarrow}h_2
\stackrel{g_{i_3}}{\longrightarrow}\dots\stackrel{g_{i_{t-1}}}{\longrightarrow}
h_{t-1}\stackrel{g_{i_t}}{\longrightarrow}h.
$$
$h$ is said to be {\bf reduced} with respect to $G$ if either $h=0$ or every
term of $h$ is indivisible by any $\lp(g_i)$, $g_i\in G$. Such an $h$ is called
a {\bf remainder} of $f$ with respect to $G$.
\end{definition}




\subsection{Multivariate division algorithm}

In the last lecture we introduced the idea of reduction (with respect to a given term order) of a polynomial $f\in\kn$ modulo a finite set of polynomials $G=\{g_1,\dots,g_s\}\subset\kn$ to a remainder $r$, say.  
Here is an algorithm for reduction.

\begin{theorem}[Division Algorithm in $\kn$]
Fix a term order on $\kn$.  Let $g_1,\dots,g_s\in\kn$.  Then for any $f\in\kn$ there
exist $u_1,\dots,u_n,r\in\kn$ such that
\begin{enumerate}
\item
$f=u_1g_1+\dots+u_sg_s+r$
and $r$ is reduced w.r.t. $G$;
\item
$
\max\{\lp(u_1)\lp(g_1),\dots,\lp(u_s)\lp(g_s),\lp(r)\}=\lp(f).
$
\end{enumerate}
\end{theorem}

The criterion that $r$ is reduced is analogous to the condition in the univariate case that $\deg r<deg g$ so that no further reduction is possible. The second condition means that there is no cancellation among higher order terms in
the quotient/remainder form. Note that it is a simple exercise to prove that $\lp(u_ig_i)=\lp(u_i)\lp(g_i)$. 

\fbox{\bf Division Algorithm}
\begin{itemize}
\item
{\bf INITIAL VALUES:} $u_1:=0,\dots,u_s:=0$, $r:=0$, $h:=f$.
\item
{\bf ALGORITHM: While $h\neq0$ do}
\begin{itemize}
\item
{\bf if} $\exists \,i,\; \lp(g_i)|\lp(h)$ {\bf then} choose least such $i$ and
\begin{eqnarray*}
u_i&:=&u_i+\frac{\lt(h)}{\lt(g_i)}\\
h&:=&h-\frac{\lt(h)}{\lt(g_i)}g_i
\end{eqnarray*}
\item
{\bf else}\kern2cm
$\begin{aligned}[t]
r&:=&r+\lt(h)\\
h&:=&h-\lt(h)
\end{aligned}$
\end{itemize}
\end{itemize}

{\bf Idea of proof.} The well-ordering of the term order ensures this algorithm terminates, as the order
of the leading power of $h$ reduces at each pass through the loop. Moreover at each stage we have
\begin{align*}
f&=u_1g_1+\dots+u_sg_s+r+h\\
\lp(f)&=\max\{\lp(u_1)\lp(g_1),\dots,\lp(u_s)\lp(g_s),\lp(r),\lp(h)\}
\end{align*}
which can be proved by induction.

{\bf Example.}
Let $f=x^2y-y\in\Q[x,y]$ and $G=\{g_1=xy-x,g_2=x^2-y\}$. Using {\sc deglex} with
$y<x$,
$$
f\stackrel{g_{1}}{\longrightarrow}x^2-y\stackrel{g_{2}}{\longrightarrow}0
$$
and $f=x.g_1+1.g_2$ with remainder $0$. However if we reversed the order of
$g_1,g_2$ we find
$$
f\stackrel{g_{2}}{\longrightarrow}y^2-y
$$
which is reduced w.r.t. $G$ and $f=y.g_2+(y^2-y)$. So remainders are not unique
even with the same term order, and indeed having non-zero remainder does not mean
that a polynomial fails to belong to the ideal generated by $G$. In fact, such
behaviour is possible even with one variable, but is resolved by replacing the
generating set by its \gcd. We now would like to find analogous well--behaved generating sets
in the multivariate case.



\subsection{{\Gr} Bases}

The problem identified in the example above is that we ran out of generators whose
leading term divided the leading term of the reduced polynomial, even though it is
in the ideal. The virtue of the {\gcd} for the one-variable case is that its
leading power is lowest among elements of the ideal it generates.  In the several
variable case we cannot hope to find a single generator but we would like to find a
set of generators with the property that any element of the ideal they generate has
its leading term divisible by at least one of the leading terms in the basis.

\begin{definition}
Given a non-zero ideal $I\subseteq\kn$ and a term order on $\T^n$, a set
$G=\{g_1,\dots,g_s\}\subseteq I$ is a {\bf {\Gr} basis} for $I$ if for all $f\in I$
there exists $g_i\in G$ such that
$\lp(g_i)|\lp(f)$.
\end{definition}

The definition begs a number of questions:
\begin{itemize}
\item
does a {\Gr} basis guarantee reduction to $0$ for any element in the ideal?
\item
is the {\Gr} basis actually a basis for $I$?
\item
does every ideal actually have a {\Gr} basis for any given term order?
\item
to what extent is a {\Gr} basis unique and how does this depend on the term order
used in the division algorithm?
\end{itemize}

\end{document}


We start by establishing a number of characterisations of {\Gr} bases which will
enable us to answer the existence question affirmatively. An important construction
is the following: for any set $S\subseteq\kn$, the {\bf leading term ideal} is 
$$
\lt(S)=\<\lt(f)\,:\,f\in S\>.
$$

\begin{theorem}
\label{grobchar}
Given a non-zero ideal $I\subseteq\kn$, the following are equivalent:
\begin{enumerate}
\item
$G\subseteq I$ is a {\Gr} basis;
\item
$f\in I$ if and only if $f\stackrel{G}{\longrightarrow}_+0$;
\item
$f\in I$ if and only if $f=\dsum_{i=1}^sh_ig_i$ with
$\lp(f)=\max\{\lp(h_i)\lp(g_i)\,:\,i=1,\dots,s\}$
\item
$\lt(G)=\lt(I)$
\end{enumerate}
\end{theorem}

\begin{proof}

$(1)\Rightarrow(2)$.  
Suppose $f\in\kn$ and $f\stackrel{G}{\longrightarrow}_+r$. If
$r=0$ then we have $f=\sum u_ig_i$ and since $g_i\in I$ for all $i$, $f\in I$.
(This establishes $\Leftarrow$ in (2), but that is always true and doesn't require
that $G$ be a {\Gr} basis.)

On the other hand, if $f\in I$ but $r\neq0$, then $r=f-\sum u_ig_i\in I$. Since $r$
is assumed reduced, $\lp(g_i)\nmid\lp(r)$ for all $i$, but this contradicts the
assumption that $G$ is a {\Gr} basis.

$(2)\Rightarrow(3)$. This is a consequence of the Division Algorithm.

$(3)\Rightarrow(4)$. 
Clearly $\lt(G)\subseteq\lt(I)$. Conversely, suppose $f\in I$. By (3), $f=\sum
h_ig_i$ and there is no cancellation among terms of higher order than $\lt(f)$ so
$\lt(f)=\sum_{j}\lt(h_j)\lt(g_j)$ where the sum is over those $j$ for which
$\lp(h_j)\lp(g_j)=\lp(f)$. Thus $\lt(f)\in\lt(G)$ and since $f$ was arbitrary,
$\lt(I)\subseteq\lt(G)$.

$(4)\Rightarrow(1)$. Exercise.
\end{proof}

\begin{corollary}
If $G=\{g_1,\dots,g_s\}$ is a {\Gr} basis for $I$ then $I=\<g_1,\dots,g_s\>$.
\end{corollary}

\begin{corollary}
Let $G$ be a {\Gr} basis and $f\in\kn$. If $f\redplus{G}r$ then $r$ is unique.
\end{corollary}

\begin{theorem}[Existence of {\Gr} Bases] 
Every non-zero ideal $I\subseteq\kn$ has
a {\Gr} bases with respect to any term order.
\end{theorem}

\begin{proof}
By the Hilbert Basis Theorem, $\lt(I)=\<h_1,\dots,h_t\>$ for some $h_i\in\lt(I)$.
In fact for each $i$,
$$
h_i=\sum_{j=1}^{s_i}u_{ij}\gt_{ij}
$$
where $\gt_{ij}=\lt(g_{ij})$ for some $g_{ij}\in I$. Let 
$$
G=\{g_{ij}\,:\,1\leq i\leq t, 1\leq j\leq s_i\}.
$$
Then for any $\phi\in\lt(I)$, 
$$
\phi=\sum_{i}v_{i}h_i=\sum_{i,j}v_iu_{ij}\gt_{ij}\in\lt(G).
$$
By Theorem~\ref{grobchar} (4), $G$ is a {\Gr} basis for $I$.
\end{proof}

This is very reassuring. However the proof is based on the non-constructive Hilbert
Basis Theorem.  What we would like ideally is an algorithm, akin to the Euclidean
Algorithm, that, given a finite basis for an ideal, would output a {\Gr} basis.
This was the significant contribution of Bruno Buchberger, who named these bases
for his research supervisor, Wolfgang {\Gr}.

\end{document}
